with Strings, Rationals, Flts, Flts.Std.Balls, Globals, Param;
use Strings, Rationals, Flts, Flts.Std.Balls, Param, Globals;
with Matrices, Vectors, ScalVectors, Fouriers2, Fouriers2.Wave;

pragma Elaborate_All (Strings,Rationals,Flts,Flts.Std.Balls,Globals,Param);
pragma Elaborate_All (Matrices,Vectors,ScalVectors,Fouriers2,Fouriers2.Wave);

procedure Check_WFix(V: in Pars) is

   subtype Scalar is Ball;

   package SM is new Matrices (Scalar => Scalar);
   package SV is new Vectors (Scalar => Scalar, Component => Scalar, SM => SM);
   package SSV is new ScalVectors (Scalar => Scalar, SM => SM, SV => SV);
   package SFouriers2 is new Fouriers2 (Deg1 => V.Deg1, Deg2 => V.Deg2, Scalar => Scalar, SM => SM, SV => SV);
   package SFouriers2_Wave is new SFouriers2.Wave (PDeg1 => V.PDeg1, PDeg2 => V.PDeg2, SSV => SSV);
   use  SM, SFouriers2, SFouriers2_Wave, SFouriers2_Wave.FContr;

   F: Fourier2;

begin

   SetEDegs(V.EDeg1,V.EDeg2);
   Show_Degs;
   Show1("kappa =",V.Kappa);
   F.T.R := (V.Rho1,V.Rho2);
   Read(Input_Dir & Strng(INum(V.Kappa)) & "-" & Strng(IDen(V.Kappa)) & ".data",F);
   CheckFix(V.Kappa,F,7/8);
   CheckCoeff(V.Kappa,F);   
   
end Check_WFix;
