with Flts.Std.Intervals;
use Flts.Std.Intervals;

package Flts.Std.EFuns is -- crude, for better speed and accuracy use MPFR version
  
  procedure Root(K: in Positive; X,DX: in LLFloat; YL,YU: out LLFloat);
  function ExpUp(R: LLFloat) return LLFloat;
  function ExpDown(R: LLFloat) return LLFloat;
  procedure Exp(X,DX: in LLFloat; YL,YU: out LLFloat);
  procedure Log(X,DX: in LLFloat; YL,YU: out LLFloat);
  procedure ArcCos(X,DX: in LLFloat; YL,YU: out LLFloat);
  procedure ArcSin(X,DX: in LLFloat; YL,YU: out LLFloat);
  procedure Cos(X: in LLFloat; YL,YU: out LLFloat);
  procedure Sin(X: in LLFloat; YL,YU: out LLFloat);
  
private
  
  RepQuarter: constant LLFloat  := LLFloat(Quarter);
  IZero:      constant Interval := (RepZero,RepZero);
  IOne:       constant Interval := (RepOne,RepOne);
  
  procedure Root(K: in Positive; X: in LLFloat; YL,YU: out LLFloat);
  procedure Log(X: in LLFloat; YL,YU: out LLFloat);
  procedure PiHalf(YL,YU: out LLFloat);
  procedure ArcCos(X: in LLFloat; YL,YU: out LLFloat);
  procedure ArcSin(X: in LLFloat; YL,YU: out LLFloat);
  procedure CosSin(S: in Interval; Sc,Ss: out Interval);
  function Cos(X: LLFloat) return Interval;
  function Sin(X: LLFloat) return Interval;
  
end Flts.Std.EFuns;
