
package Flts.Std.Intervals is --- just a few simple ops
  
  pragma Elaborate_Body;
  
  function PowerDown(I: Integer; X: Rep) return Rep;
  function PowerUp(I: Integer; X: Rep) return Rep;
  
  type Interval is  -- [L,U]
    record
      L: Rep; -- lower bound
      U: Rep; -- upper bound
    end record;
  
  function Scal(R: Flt) return Interval;
  function Maxabs(S: Interval) return Rep;
  function "abs"(S: Interval) return Interval;
  function Union(S1,S2: Interval) return Interval;
  function "-"(S: Interval) return Interval;
  function "+"(S1,S2: Interval) return Interval;
  function "-"(S1,S2: Interval) return Interval;
  function "*"(R: Rep; S: Interval) return Interval;
  function "*"(S1,S2: Interval) return Interval;
  function Sqr(S: Interval) return Interval;
  function "/"(S: Interval; R: Rep) return Interval;
  function "/"(R: Rep; S: Interval) return Interval;
  function "/"(S1,S2: Interval) return Interval;
  function "**"(S: Interval; I: Integer) return Interval;
  function Sqrt(S: Interval) return Interval;
  function PiHalf return Interval;
  procedure Proper_Rounding(Dummy: in Interval);
  
end Flts.Std.Intervals;
