with ScalVectors, Fouriers2.Contr;

pragma Elaborate_All (Fouriers2.Contr);
   
generic
  
  HPos: in Boolean := False;
  PDeg1,PDeg2: in Positive; --- pack degrees, choose odd if JustOdd is true
  
  with package SSV is new ScalVectors (Scalar => Scalar, SM => SM, SV => SV);

package Fouriers2.BBeam is   --- for frequency Alpha=1/Sqrt(BB)
  
  procedure InvLinear(BB: in Positive; F: in out Fourier2);
  procedure MapB(BB: in Positive; F: in Fourier2; G: in out Fourier2);
  procedure DMapB(BB: in Positive; F: in Fourier2; H: in out Fourier2);
  
  package BContr is new Fouriers2.Contr (PDeg1 => PDeg1, PDeg2 => PDeg2, Param => Positive,
                                         SSV => SSV, Map => MapB, DMap => DMapB);
private
  
  function Phi1(BB: Positive; K: Natural) return Integer;
  function Phi2(BB: Positive; N: Natural) return Integer;
  
end Fouriers2.BBeam;
