with Rationals, ScalVectors, Fouriers2.Contr;
use Rationals;

pragma Elaborate_All (Rationals,Fouriers2.Contr);
   
generic
  
  HPos: in Boolean := False;
  PDeg1,PDeg2: in Positive; --- pack degrees, choose odd if JustOdd is true
  
  with package SSV is new ScalVectors (Scalar => Scalar, SM => SM, SV => SV);

package Fouriers2.KBeam is  --- for rational frequencies
  
  procedure InvLinear(Kappa: in Rational; F: in out Fourier2);
  procedure MapK(Kappa: in Rational; F: in Fourier2; G: in out Fourier2);
  procedure DMapK(Kappa: in Rational; F: in Fourier2; H: in out Fourier2);
  
  package KContr is new Fouriers2.Contr (PDeg1 => PDeg1, PDeg2 => PDeg2, Param => Rational,
                                         SSV => SSV, Map => MapK, DMap => DMapK);
  use KContr;
  
------------ numerical  
  procedure Find_Fix(Kap: in Rational; F: in out Fourier2; A: in out PMat; OK: out Boolean);
  function Norm0(F: Fourier2) return Radius;
  function ProjNorm0(NFac,KFac: Positive; F: Fourier2) return Radius;
  procedure Plot3(FileName: in String; R1,R2: in Flt; I: in Integer);
  
end Fouriers2.KBeam;
