
package body Fouriers2.NBeam is
  
  use SM,SV,SSV;
  
  function Beta(Kappa: in Rational) return Scalar is
  begin
    return Scal(IDen(Kappa))/Flt(INum(Kappa))+DiskAt0(DeltaHalf);
  end Beta;
  
  procedure InvLinear(Kappa: in Rational; F: in out Fourier2) is
--- assumes Flt operations round up
    P: constant Integer := INum(Kappa);
    B: constant  Scalar := Beta(Kappa);
    BB: constant Scalar := B*B;
    U: constant  Scalar := Flt(4*P*P)*BB/Flt(7);
    V: constant  Scalar := Scal(7)/Flt(16);
    K1,N1: Integer;
    A: Scalar;
    C: FCoeff renames F.C;
    E: FErr renames F.E;
  begin
    for K in Freq2 loop
      A := Flt(K*K)*B;
      A := A*A;
      for N in Freq1 loop
        if not IsZero(C(N,K)) then
          C(N,K) := BB*C(N,K)/(A-Scal(N*N));
        end if;
      end loop;
    end loop;
    if not STrunc then
      for K in 0 .. DegE2 loop
        K1 := 2*(K/2)+1;
        A := Flt(K1*K1)*B;
        for N in 0 .. DegE1 loop
          if E(N,K) /= Zero then
            N1 := 2*(N/2)+1;
            E(N,K) := E(N,K)*Sup(U/(Flt(P)*Max(A,Scal(N1))-V));
          end if;
        end loop;
      end loop;
    end if;
  end InvLinear;
 
  procedure MapN(Kappa: in Rational; F: in Fourier2; G: in out Fourier2) is
  begin
    Prod(F,F,G);
    Mult(F,G);
    InvLinear(Kappa,G);
    if HPos then Neg(G); end if;
  end MapN;

  procedure DMapN(Kappa: in Rational; F: in Fourier2; H: in out Fourier2) is
  begin
    Mult(F,H);
    Mult(F,H);
    InvLinear(Kappa,H);
    if HPos then
      Mult(-Three,H);
    else
      Mult(Three,H);
    end if;
  end DMapN;
  
end Fouriers2.NBeam;
