with Rationals, ScalVectors, Fouriers2.Contr;
use Rationals;

pragma Elaborate_All (Rationals,Fouriers2.Contr);
   
generic
  
  HPos: in Boolean := False;
  PDeg1,PDeg2: in Positive; --- pack degrees, choose odd if JustOdd is true
  
  with package SSV is new ScalVectors (Scalar => Scalar, SM => SM, SV => SV);

package Fouriers2.NBeam is   --- for frequencies near Kappa
  
  DeltaHalf: constant Radius := Half**80;
  
  function Beta(Kappa: in Rational) return Scalar;
  
  procedure InvLinear(Kappa: in Rational; F: in out Fourier2);
  procedure MapN(Kappa: in Rational; F: in Fourier2; G: in out Fourier2);
  procedure DMapN(Kappa: in Rational; F: in Fourier2; H: in out Fourier2);
  
  package NContr is new Fouriers2.Contr (PDeg1 => PDeg1, PDeg2 => PDeg2, Param => Rational,
                                         SSV => SSV, Map => MapN, DMap => DMapN);
end Fouriers2.NBeam;
