with Rationals, ScalVectors, Fouriers2.Contr;
use Rationals;

pragma Elaborate_All (Rationals,Fouriers2.Contr);
   
generic

   PDeg1,PDeg2: in Positive;    --- pack degrees, choose odd if JustOdd is true
   
   with package SSV is new ScalVectors (Scalar => Scalar, SM => SM, SV => SV);

package Fouriers2.Wave is

   use SM,SV,SSV;
   
--- existence
   procedure SetZeroKernel(Kappa: in Rational; F: in out Fourier2);
   procedure AddKernel(Kappa: in Rational; F: in Fourier2; G: in out Fourier2);
   function Kernel(Kappa: Rational; F: Fourier2) return Fourier2;
   procedure InvLinear(Kappa: in Rational; F: in out Fourier2);
   procedure MapA(Kappa: in Rational; F: in Fourier2; G: in out Fourier2);
   procedure DMapA(Kappa: in Rational; F: in Fourier2; H: in out Fourier2);
   procedure CheckCoeff(Kappa: in Rational; F: in Fourier2);
   
   DegP1: constant Positive := 2*(Deg1/2)-1;
   DegP2: constant Positive := 2*(Deg2/2)-1;
   
   package FContr is new Fouriers2.Contr (PDeg1 => PDeg1, PDeg2 => PDeg2, Param => Rational,
                                          SSV => SSV, Map => MapA, DMap => DMapA);
   use FContr;
   
--- numerical
   
   procedure Find_Fix(Kappa: in Rational; V1: in out Fourier2);
   procedure Find_Fix(Kappa: in Rational; NameIn,NameOut: in String);
   
end Fouriers2.Wave;
