with Logicals, Flts;
use Logicals, Flts;

pragma Elaborate_All (Logicals,Flts);

generic
  
  with function IsSharp(S: Scalar) return Boolean is <>;
  with function Center0(S: Scalar) return Boolean is <>;
  with function Contains0(S: Scalar) return Logical is <>;
  with function Contains(S1,S2: Scalar) return Logical is <>;
  with procedure ToErr(S: in out Scalar) is <>;
  with procedure ToErr(S1: in Scalar; S2: in out Scalar) is <>;
  with procedure Center(S: in out Scalar) is <>;
  with procedure Center(S1: in Scalar; S2: in out Scalar) is <>;
  with procedure ModCenter(S: in out Scalar) is <>;
  with procedure ModCenter(S1: in Scalar; S2: in out Scalar) is <>;
--  with procedure ErrMult(R: in Radius; S: in out Scalar) is <>;
--  with procedure Union(S1: in Scalar; S2: in out Scalar) is <>;
--  with procedure Intersection(S1: in Scalar; S2: in out Scalar; Empty: out Logical) is <>;
--  with procedure Min(S1: in Scalar; S2: in out Scalar) is <>;
--  with procedure Max(S1: in Scalar; S2: in out Scalar) is <>;
--  with function Inf(S: Scalar) return Flt is <>;
--  with function Sup(S: Scalar) return Flt is <>;
--  with procedure Mult(R: in Flt; S: in out Scalar) is <>;
  with procedure Mult(R: in Flt; S,Tmp: in out Scalar) is <>;
  with procedure Prod(R: in Flt; S1: in Scalar; S2: in out Scalar) is <>;
  with procedure AddProd(R: in Flt; S1: in Scalar; S2,Tmp: in out Scalar) is <>;
  with procedure Div(R: in Flt; S,Tmp: in out Scalar) is <>;
  with procedure Quot(S1: in Scalar; R: in Flt; S2: in out Scalar) is <>;
  
package Matrices.More is
  
  function IsSharp is new MF_BProperty (Scalar,Matrix,IsSharp);
  function Center0 is new MF_BProperty (Scalar,Matrix,Center0);
  function Contains0 is new MF_LProperty (Scalar,Matrix,Contains0);
  function Contains is new MF_LSimilar (Scalar,Matrix,Contains);
  procedure ToErr is new MP_Modify1 (Scalar,Matrix,ToErr);
  procedure ToErr is new MP_Map1 (Scalar,Matrix,ToErr);
  procedure Center is new MP_Modify1 (Scalar,Matrix,Center);
  procedure Center is new MP_Map1 (Scalar,Matrix,Center);
  procedure ModCenter is new MP_Modify1 (Scalar,Matrix,ModCenter);
  procedure ModCenter is new MP_Map1 (Scalar,Matrix,ModCenter);
  --  procedure ErrMult(R: in Radius; V: in out Matrix);
  --  procedure Union is new MP_Map1 (Scalar,Matrix,Union);
  --  procedure Intersection(V1: in Matrix; V2: in out Matrix; Empty: out Logical);
  --  procedure Min(V: in Matrix; S: in out Scalar);
  --  procedure Max(V: in Matrix; S: in out Scalar);
  --  function Sup(V: Matrix) return Flt;
  --  function Inf(V: Matrix) return Flt;
  procedure Mult(R: in Flt; M: in out Matrix; Tmp: in out Scalar);
  procedure Prod(R: in Flt; M1: in Matrix; M2: in out Matrix);
  procedure AddProd(R: in Flt; M1: in Matrix; M2: in out Matrix; Tmp: in out Scalar);
  procedure Div(R: in Flt; M: in out Matrix; Tmp: in out Scalar);
  procedure Quot(M1: in Matrix; R: in Flt; M2: in out Matrix);
  
  --  procedure Evaluate(P: in Polynom1; R: in Flt; C: in out Scalar; Deg: in Natural);
  --  procedure Evaluate(P: in Polynom1; R: in Flt; C: in out Scalar);
  --  function Evaluate(P: Polynom1; R: Flt; Deg: Natural) return Scalar;
  --  function Evaluate(P: Polynom1; R: Flt) return Scalar;
  --  procedure Num_Der(P: in out Polynom1);                                         -- derivative
  --  procedure Num_ValDer(P: in Polynom1; S: in Scalar; C: in out Scalar);
  --  procedure Num_MDer(P: in out Polynom1);                                        -- generator of dilation
  --  procedure Inv_MDer(P: in out Polynom1; CheckConst: in Boolean := True);        -- inverse of MDer

end Matrices.More;
