with Rationals, Flts;
use Rationals, Flts;

pragma Elaborate_All (Rationals,Flts);

package Param is
  
  type Pars is
    record
      Kappa:        Rational;
      Deg1, Deg2:   Positive; --- last explicit Degrees
      PDeg1, PDeg2: Positive; --- degrees for Pack/UnPack
      EDeg1, EDeg2: Positive; --- used in DContractNorm
      Rho1, Rho2:   Radius;
    end record;
  
  type ParsVec is array(Integer range <>) of Pars;
  
  function "/"(N: Integer; P: Positive) return Flt renames Frac;
  function Strng(Kappa: Rational; W: Positive := 4) return String;
  function Approx(Q: in Rational) return Flt;
  function Check_Upper(C: Character) return Boolean;
  
end Param;
