with Ada.Text_IO;
use Ada.Text_IO;

pragma Elaborate_All (Ada.Text_IO);

package Rationals is  --- not for major computations
  
  subtype LInt is Long_Long_Integer;
  
  package LInt_IO is new Ada.Text_IO.Integer_IO (LInt);
  
  function GCD(N,D: LInt) return LInt;
  function Width(I: LInt; Base: Positive := 10) return Positive;
  
  type Rational is private;
  
  function LRat(N,D: LInt) return Rational;
  function Rat(N,D: LInt) return Rational renames LRat;
  function IRat(N,D: Integer) return Rational;
  function Rat(N,D: Integer) return Rational renames IRat;
  function LNum(Q: Rational) return Lint;
  function Num(Q: Rational) return Lint renames LNum;
  function INum(Q: Rational) return Integer;
  function Num(Q: Rational) return Integer renames INum;
  function LDen(Q: Rational) return Lint;
  function Den(Q: Rational) return Lint renames LDen;
  function IDen(Q: Rational) return Integer;
  function  Den(Q: Rational) return Integer renames IDen;
  
  function "-"(Q: Rational) return Rational;
  function "+"(I: LInt; Q: Rational) return Rational;
  function "+"(Q: Rational; I: LInt) return Rational;
  function "+"(P,Q: Rational) return Rational;
  function "-"(I: LInt; Q: Rational) return Rational;
  function "-"(Q: Rational; I: LInt) return Rational;
  function "-"(P,Q: Rational) return Rational;
  function "*"(I: LInt; Q: Rational) return Rational;
  function "*"(Q: Rational; I: LInt) return Rational;
  function "*"(P,Q: Rational) return Rational;
  function "/"(N,D: LInt) return Rational renames Rat;
  function "/"(I: LInt; Q: Rational) return Rational;
  function "/"(Q: Rational; I: LInt) return Rational;
  function "/" (P,Q: Rational) return Rational;
  function "abs"(Q: Rational) return Rational;
  function "<"(P,Q: Rational) return Boolean;
  
  procedure Show1(N: in String; Q: in Rational; NewLine: in Boolean := True);
  
private
  
  type Rational is
    record
      Num : LInt;
      Den : LInt;
    end record;
  
end Rationals;
