with Ada.Text_IO, Ada.Task_Identification, Ada.Task_Attributes;
use Ada, Ada.Text_IO;

pragma Elaborate_All(Ada.Text_IO,Ada.Task_Identification,Ada.Task_Attributes);

package Tasks is --- a leftover from something more useful
  
  MaxLog: constant Positive := 16;
  
  subtype Log_Range is Integer range 0 .. MaxLog;
  
  type Attribute is
    record
      Level: Natural   := 0;  -- trace level
      Log:   Log_Range := 0;  -- log file, 0 means Current_Output
    end record;
  
  Initial_Value: constant Attribute := (Level => 0, Log  => 0);
  package Attributes is new Task_Attributes(Attribute,Initial_Value);      -- assign Attributes to tasks
  
  subtype Task_Id is Ada.Task_Identification.Task_Id;
  subtype Attribute_Handle is Attributes.Attribute_Handle;                 -- access all Attribute
  
  function Current_Task return Task_Id renames Ada.Task_Identification.Current_Task;                    -- Task_Id for current task
  function Value(ID: Task_Id := Current_Task) return Attribute renames Attributes.Value;                -- Attribute for a task
  function Reference(ID: Task_Id := Current_Task) return Attribute_Handle renames Attributes.Reference; -- Attribute_Handle for a task
  procedure Reinitialize(ID: in Task_Id := Current_Task) renames Attributes.Reinitialize;               -- reset Attribute to Initial_Value
  
  function Task_Log(H: in Attribute_Handle) return File_Access;             -- now just returns Current_Output
  function Task_Log(ID: in Task_Id := Current_Task) return File_Access;     -- now just returns Current_Output
  
end Tasks;
